﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@model CyberaniumModels.RiskAssessment
<script src="~/Script/Master/Layout.js"></script>
<style>
    .domaincls {
        height: calc(100vh - 220px);
        padding: 0px 12px 15px;
        background: #f8f8f8;
        overflow-y: auto;
    }

        .domaincls .table_control {
            margin-top: 12px;
        }

    tr td:first-child {
        text-align: left;
    }

    #Observation {
        height: 100px !important;
        width: 100% !important;
    }

    .modal-content {
        width: 538px;
    }
</style>
<section>
    @Html.HiddenFor(m => m.OrgId)
    @Html.HiddenFor(m => m.QuestionnaireID)
    @Html.HiddenFor(m => m.CategoryId)
    @Html.HiddenFor(m => m.CategoryName)
    <div hidden>
        @{
            var listICDId = Model.RAList.Select(x => x.ICDID).Distinct().ToArray();
        }
        <table>
            @foreach (var icdId in listICDId)
            {
                var commentList = Model.RAList.Where(x => x.ICDID == icdId).ToList();
                <tr class="trICD" id="@icdId">
                    @foreach (var item in commentList)
                    {
                        <td class="td@(icdId)">
                            <input type="hidden" value="@item.ObservationCmnt" />
                            <input type="hidden" value="@item.RecomedationCmnt" />
                        </td>
                    }
                </tr>
            }
        </table>
    </div>
    <div class="right_section">
        <div class="pb-2 mt-3 mb-2 border-bottom box_title pl-4">
            Control Assessment for @Model.CategoryName
            @if (Model.IsTask)
            {
                <a data-ajax="true" class="backtolist" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="GovernanceReports" asp-controller="Landing" asp-area="Dashboard">Back to Menu</a>
            }
            else
            {
                <a data-ajax="true" class="backtolist" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="Index" asp-controller="RiskAssessment" asp-area="ApplicationManagement" asp-route-orgId="@Model.OrgId" asp-route-CategoryId="@Model.CategoryId" asp-route-QuestionnaireID="@Model.QuestionnaireID" asp-route-EnablerName="@Model.CategoryName">Back to Menu</a>

            }
        </div>
        <div class="col-lg-12 col-md-8 col-sm-8 col-xs-8">
            <div class="right_panel">
                <div class="right_content">
                    <div class="row" id="MainDiv">
                        <div class="col-md-12 col-sm-12 col-xs-12">
                            <div class="domaincls">
                                <div class="p-3">
                                    <a data-ajax="true" class="backtolist" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="Artifacts" asp-controller="RiskAssessment" asp-area="ApplicationManagement" asp-route-orgId="@Model.OrgId" asp-route-CategoryId="@Model.CategoryId" asp-route-QuestionnaireID="@Model.QuestionnaireID" asp-route-EnablerName="@Model.CategoryName">Request Artifacts</a>
                                </div>
                                <div class="table_control">
                                    <table class="table" id="tblControlAssessment">
                                        <thead>
                                            <tr>
                                                <th width="11%">Control Name</th>
                                                <th width="31%">Control Description</th>
                                                <th width="10%">Control ID</th>
                                                <th width="12%">Artefacts</th>
                                                <th width="12%">Rating</th>
                                                <th width="12%">Observation</th>
                                                <th width="12%">Recommendation</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            @{int sn = 0;}
                                            @foreach (var item in Model.RCMControlByOrgLatestList)
                                            {
                                                <tr>
                                                    <td><input type="hidden" class="ICDId" value="@item.ICDID" />@item.ControlName</td>
                                                    <td><input type="hidden" value="@item.DomainID" />@item.ControlDescription</td>
                                                    <td><input type="hidden" value="@item.DomainName" />@item.ControlId</td>
                                                    <td>
                                                        <input type="hidden" value="@item.SubDomainID" />
                                                        <div style="margin-left:10px;">
                                                            <ol>
                                                                @if (!String.IsNullOrEmpty(item.ArtefactName))
                                                                {
                                                                    foreach (var item2 in item.ArtefactName.Split(","))
                                                                    {
                                                                        <li>@item2</li>
                                                                    }
                                                                }
                                                            </ol>
                                                        </div>
                                                    </td>
                                                    <td><input type="hidden" value="@item.SubDomainName" /><input type="number" min="1" max="5" value="@item.Rating" onchange="return Validate(this,@item.ICDID)" class="form-control clsRating_@item.ICDID" /> </td>
                                                    <td>
                                                        <input type="hidden" value="@item.ControlTypeID" />
                                                        <input type="text" value="@item.Observation" class="form-control main_Observation" onclick="fn_Popup(this,'@(sn)','`.main_Observation`',0)" />
                                                        @if (Model.IsTask)
                                                        {

                                                            <a href="#" class="ObservationCmnt">
                                                                <i class="fa fa-comment" onclick="fn_addcmnt(this,'@(sn)','`.ObservationCmnt`')"></i>
                                                                <i class="fa fa-info-circle" id="obs@(@item.ICDID)" title="Comment" data-toggle="popover" onclick="fn_CloseAllPopover(this)"></i>
                                                            </a>
                                                        }
                                                        else if (item.Status2 == 1)
                                                        {
                                                            <i class="fa fa-envelope" data-toggle="tooltip" data-placement="top" title="@item.ObservationCmnt"></i>
                                                        }

                                                    </td>
                                                    <td>
                                                        <input type="text" value="@item.Recommendation" class="form-control main_Recommendation" onclick="fn_Popup(this,'@(sn)','`.main_Recommendation`',1)" />
                                                        @if (Model.IsTask)
                                                        {
                                                            <a href="#" class="RecomedationCmnt">
                                                                <i class="fa fa-comment" onclick="fn_addcmnt(this,'@(sn)','`.RecomedationCmnt`')"></i>
                                                                <i class="fa fa-info-circle" id="rec@(@item.ICDID)" title="Comment" data-toggle="popover" onclick="fn_CloseAllPopover(this)"></i>
                                                            </a>
                                                        }
                                                        else if (item.Status2 == 1)
                                                        {
                                                            <i class="fa fa-envelope" data-toggle="tooltip" data-placement="top" title="@item.RecomedationCmnt"></i>
                                                        }
                                                    </td>
                                                </tr>
                                                sn++;
                                            }
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                    @if (Model.IsTask)
                    {
                        <div>
                            <div class="submitbtn">
                                <input type="submit" class="btn btn-primary pull-right" value="Sign off" onclick="fn_RemoveTask('@Model.OrgId', '@Model.CategoryId', '@Model.QuestionnaireID')" />
                            </div>
                            <div class="back_btn">
                                <div class="submitbtn">
                                    <input type="submit" class="btn btn-info pull-right" value="Return" onclick="fn_AddCmnt()" />
                                </div>
                            </div>
                        </div>
                    }
                    else
                    {
                        <div class="row justify-content-end pt-3">
                            <div class="col-5">
                                <div class="row">
                                    <div class="col-4">
                                        @Html.Label("send for approval")
                                    </div>
                                    <div class="col-7">
                                        @Html.DropDownListFor(m => m.RoleId, Model.DdlRole, new { @class = "form-control m_no multiple chosen-select", @multiple = "multiple", placeholder = "search" })
                                    </div>
                                    <div class="col-1">
                                        <button type="button" class="btn btn-primary" onclick="approvalforsave()">save</button>
                                    </div>
                                </div>
                            </div>
                            <div class="col-3">
                                <div class="row justify-content-end">
                                    @if (Model.Status == 0)
                                    {
                                        <div class="col-8 text-right">
                                            <input type="button" class="btn btn-info" value="Save as draft" onclick="PrepareToSave()">
                                        </div>
                                    }
                                    <div class="col-4 text-right">
                                        <input type="button" class="btn btn-primary" value="Submit" onclick="PrepareToSubmit()">
                                    </div>
                                </div>
                            </div>
                        </div>
                    }
                </div>
            </div>
        </div>
    </div>
</section>
<div class="modal fade" id="ObservationTextBox" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered modal-lg " role="document">
        <div class="modal-content">
            <div class="pb-2 mt-4 mb-2 border-bottom box_title pl-4" id="modaltext"></div>
            <div class="modal-body">
                <div class="row" style=" margin-bottom: 10px;">
                    <div class="col-12">
                        @Html.TextAreaFor(m => m.Observation, new { @class = "form-control m_no" })
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <a class="btn btn-danger" data-dismiss="modal" href="#ObservationTextBox">Close</a>
                <button type="button" class="btn btn-primary" id="btn_submit">Submit</button>
            </div>
        </div>
    </div>
</div>
<div class="modal fade" id="ObservationCommentBox" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered modal-lg " role="document">
        <div class="modal-content">
            <div class="pb-2 mt-4 mb-2 border-bottom box_title pl-4" id="modaltext">Add Comment</div>
            <div class="modal-body">
                <div class="row" style=" margin-bottom: 10px;">
                    <div class="col-12">
                        @Html.TextAreaFor(m => m.Comment, new { @class = "form-control m_no" })
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <a class="btn btn-danger" data-dismiss="modal" href="#ObservationCommentBox">Close</a>
                <button type="button" class="btn btn-primary" id="btn_OK">OK</button>
            </div>
        </div>
    </div>
</div>

<script>
    $(document).ready(function () {
        $('.trICD').each((i, tr) => {
            var icdId = Number($(tr).attr('id'));
            var obsLI = '<div style="padding-left:15px;"><ol>';
            var recLI = '<div style="padding-left:15px;"><ol>';
            $('.td' + icdId).each((i, td) => {
                var obs = $(td).find('input').eq(0).val();
                var rec = $(td).find('input').eq(1).val();
                obsLI += '<li>' + obs + '</li>';
                recLI += '<li>' + rec + '</li>';
            })
            obsLI += '</ol></div>';
            recLI += '</ol></div>';
            $('#obs' + icdId).attr('data-content', obsLI);
            $('#rec' + icdId).attr('data-content', recLI);
        })
        $('[data-toggle="tooltip"]').tooltip()
        $('[data-toggle="popover"]').popover({ html: true, sanitize: false, })
        $('select[name=RoleId]').val([@Model.ApprovalFor]).change();
        $('.multiple').multiselect('rebuild');
        $('#tblControlAssessment tbody tr').each(function (i, tr) {
            var value = $(tr).find("td:nth-child(5) input[type=number]").val();
            var backgroundColor = (value == 1 ? "rgb(190 26 26)" : value == 2 ? "#ffcdaa" : value == 3 ? "#ffbb3d" : value == 4 ? "rgb(195 246 195)" : value == 5 ? "rgb(93 178 93)" : "white");
            var TextColor = (value == 1 ? "white" : value == 2 ? "black" : value == 3 ? "black" : value == 4 ? "black" : value == 5 ? "white" : "black")
            $(tr).find("td:nth-child(5) input[type=number]").css({ "background-color": backgroundColor });
            $(tr).find("td:nth-child(5) input[type=number]").css({ "color": TextColor });
        })
    })
    function fn_CloseAllPopover($this) {
        $('[data-toggle="popover"]').not($this).popover('hide');
        $($this).popover('toggle');
    }
    $('[data-toggle="popover"]').click((e) => { e.stopPropagation() })
    $(document).click((e) => {
        $('[data-toggle="popover"]').popover('hide')
    });
    function fn_RemoveTask(OrgId, CategoryId, QuestionnaireID) {
        debugger
        $.ajax({
            url: "/ApplicationManagement/RiskAssessment/RemoveTask",
            type: "POST",
            data: { OrgId: OrgId, CategoryId: CategoryId, QuestionnaireID: QuestionnaireID},
            success: function (res) {
                if (res>0) {
                    toastr.success('Task Completed!.');
                    $.get('/Dashboard/Landing/GovernanceReports',  (res) => $('#ajaxresult').html(res))
                } else {
                    toastr.error('Something went wrong!');
                }

            }
        });
    }
    function fn_AddCmnt() {
        if ($('#Comment').val() == '') {
            toastr.error('Please add atleast one comment or "SignOff"');
        } else {
            var Array = [], sn = 0;
            $('#tblControlAssessment tbody tr').each(function (i, tr) {
                debugger;
                var OCmnt = $(tr).find("td:nth-child(6) a").attr('value');
                var RCmnt = $(tr).find("td:nth-child(7) a").attr('value');
                var ICDId = Number($(tr).find("td:nth-child(1) input[type=hidden]").val());
                if (OCmnt === undefined && RCmnt === undefined) return;
                if (OCmnt === undefined) OCmnt = null;
                if (RCmnt === undefined) RCmnt = null;
                Array[sn++] = {
                    ICDId: ICDId,
                    ObservationCmnt: OCmnt,
                    RecomedationCmnt: RCmnt
                }
            });
            var model = {
                OrgId: $("#OrgId").val(),
                CategoryId: $("#CategoryId").val(),
                Status: 1,
                QuestionnaireId: $("#QuestionnaireID").val(),
                xmlControlAssessment: JSON.stringify(Array)
            }
            $.post('/ApplicationManagement/RiskAssessment/SaveComment', { model: model }, function (res) {
                if (res.isSuccess) {
                    toastr.success('Saved successfully.');
                    $.get('/Dashboard/Landing/GovernanceReports', (res) => $('#ajaxresult').html(res))
                } else {
                    toastr.error('Something went wrong!');
                }
            })
        }
    }
    function fn_addcmnt(input, sn, _class) {
        var value = $(input).attr('value');
        $('#Comment').val(value);
        $('#btn_OK').attr('onclick', 'fn_saveObservationCmnt(' + _class + ',' + sn + ')');
        $('#ObservationCommentBox').modal('show');
        $('#ObservationCommentBox').on('shown.bs.modal', function () {
            $('#Comment').focus();
        })
    }
    function fn_saveObservationCmnt(_class, sn) {
        $(_class).eq(sn).attr('value',$('#Comment').val());
        $('#ObservationCommentBox').modal('hide');
    }
    function Validate(input, ICDID) {
        if (parseInt($(input).val()) < 1 || parseInt($(input).val()) > 5) {
            toastr.warning('Control rating score should be between 1 to 5.');
            $(input).val('');
            return false;
        }
        var backgroundColor = (parseInt($(input).val()) == 1 ? "rgb(190 26 26)" : parseInt($(input).val()) == 2 ? "#ffcdaa" : parseInt($(input).val()) == 3 ? "#ffbb3d" : parseInt($(input).val()) == 4 ? "rgb(195 246 195)" : parseInt($(input).val()) == 5 ? "rgb(93 178 93)" : "white");
        var TextColor = (parseInt($(input).val()) == 1 ? "white" : parseInt($(input).val()) == 2 ? "black" : parseInt($(input).val()) == 3 ? "black" : parseInt($(input).val()) == 4 ? "black" : parseInt($(input).val()) == 5 ? "white" : "black")
        $(".clsRating_" + ICDID).css({ "background-color": backgroundColor });
        $(".clsRating_" + ICDID).css({ "color": TextColor });
    }
    function PrepareToSave() {
        var Array = [];
        $('#tblControlAssessment tbody tr').each(function (i, tr) {
            Array[i] = {
                ICDID: $(tr).find("td:nth-child(1) input[type=hidden]").val(),
                ControlName: $(tr).find("td:nth-child(1)").text(),
                DomainID: $(tr).find("td:nth-child(2) input[type=hidden]").val(),
                ControlDescription: $(tr).find("td:nth-child(2)").text(),
                DomainName: $(tr).find("td:nth-child(3) input[type=hidden]").val(),
                ControlId: $(tr).find("td:nth-child(3)").text(),
                SubDomainID: $(tr).find("td:nth-child(4) input[type=hidden]").val(),
                ArtefactName: $(tr).find("td:nth-child(4)").text(),
                SubDomainName: $(tr).find("td:nth-child(5) input[type=hidden]").val(),
                Rating: $(tr).find("td:nth-child(5) input[type=number]").val(),
                ControlTypeID: $(tr).find("td:nth-child(6) input[type=hidden]").val(),
                Observation: $(tr).find("td:nth-child(6) input[type=text]").val(),
                Recommendation: $(tr).find("td:nth-child(7) input[type=text]").val(),
            }
        })
        var model = {
            OrgId: $("#OrgId").val(),
            CategoryId: $("#CategoryId").val(),
            Status: 0,
            QuestionnaireID: $("#QuestionnaireID").val(),
            xmlControlAssessment: JSON.stringify(Array)
        }
        $.post('/ApplicationManagement/RiskAssessment/SaveUpdateControlAssessment', { model: model }, function (res) {
            if (res.isSuccess) {
                toastr.success('Saved successfully.');
                $.get('/ApplicationManagement/RiskAssessment/Index', { orgId: $("#OrgId").val(), CategoryId: $("#CategoryId").val(), QuestionnaireID: $("#QuestionnaireID").val(), EnablerName: $("#CategoryName").val() }, (res) => $('#ajaxresult').html(res))
            } else {
                toastr.error('Something went wrong!');
            }
        })
    }
    function PrepareToSubmit() {
        var Array = [];
        $('#tblControlAssessment tbody tr').each(function (i, tr) {
            Array[i] = {
                ICDID: $(tr).find("td:nth-child(1) input[type=hidden]").val(),
                ControlName: $(tr).find("td:nth-child(1)").text(),
                DomainID: $(tr).find("td:nth-child(2) input[type=hidden]").val(),
                ControlDescription: $(tr).find("td:nth-child(2)").text(),
                DomainName: $(tr).find("td:nth-child(3) input[type=hidden]").val(),
                ControlId: $(tr).find("td:nth-child(3)").text(),
                SubDomainID: $(tr).find("td:nth-child(4) input[type=hidden]").val(),
                ArtefactName: $(tr).find("td:nth-child(4)").text(),
                SubDomainName: $(tr).find("td:nth-child(5) input[type=hidden]").val(),
                Rating: $(tr).find("td:nth-child(5) input[type=number]").val(),
                ControlTypeID: $(tr).find("td:nth-child(6) input[type=hidden]").val(),
                Observation: $(tr).find("td:nth-child(6) input[type=text]").val(),
                Recommendation: $(tr).find("td:nth-child(7) input[type=text]").val(),
            }
        })
        var model = {
            OrgId: $("#OrgId").val(),
            CategoryId: $("#CategoryId").val(),
            Status: 1,
            QuestionnaireID: $("#QuestionnaireID").val(),
            xmlControlAssessment: JSON.stringify(Array)
        }
        $.post('/ApplicationManagement/RiskAssessment/SaveUpdateControlAssessment', { model: model }, function (res) {
            if (res.isSuccess) {
                toastr.success('Saved successfully.');
                $.get('/ApplicationManagement/RiskAssessment/Index', { orgId: $("#OrgId").val(), CategoryId: $("#CategoryId").val(), QuestionnaireID: $("#QuestionnaireID").val(), EnablerName: $("#CategoryName").val() }, (res) => $('#ajaxresult').html(res))
            } else {
                toastr.error('Something went wrong!');
            }
        })
    }
    function fn_Popup(input, sn, _class, id) {
        var value = $(input).val();
        $('#Observation').val(value);
        $('#modaltext').text(id > 0 ? 'Recommendation' : 'Observation');
        $('#btn_submit').attr('onclick', 'fn_saveObservation(' + _class + ',' + sn + ')');
        $('#ObservationTextBox').modal('show');
        $('#ObservationTextBox').on('shown.bs.modal', function () {
            $('#Observation').focus();
        })
       }
    function fn_saveObservation(_class, sn) {
        $(_class).eq(sn).val($('#Observation').val());
        $('#ObservationTextBox').modal('hide');
    }
    function approvalforsave() {

        if ($('#RoleId').val() == "" || $('#RoleId').val() == null) {
            toastr.error('Please select Atleast one option! ')
            return false;
        }
        else {
            var model = {
                OrgId: $("#OrgId").val(),
                CategoryId: $("#CategoryId").val(),
                QuestionnaireID: $("#QuestionnaireID").val(),
                ApprovalFor: $("#RoleId").val().toString().replace("multiselect-all,", "")
            }
        }
        $.ajax({
            url: "/ApplicationManagement/RiskAssessment/SaveApprovalfor",
            type: "POST",
            data: { model: model },
            success: function (res) {
                if (res.isSuccess) {
                    toastr.success('Assigned Successfully.')
                } else {
                    toastr.error('Somthing went wrong!');
                }
            },
            error: function (ex) {
                console.log(ex.responseText);
            }
        })

    }
</script>